#include "StdAfx.h"
#include "MQOPlugin.h"
#include "MQOObjectFactory.h"
#include "GLMetaseq.h"

// \z܂B
MQOPlugin::MQOPlugin(void)
{
	mqoInit();
}

// j܂B
MQOPlugin::~MQOPlugin(void)
{
	mqoCleanup();
}

// A^b`܂B
STDMETHODIMP MQOPlugin::Attach(IARGPluginEnvironment* pEnv)
{
	if(pEnv == NULL) {
		return E_POINTER;
	}

	MQOObjectFactory* pFactory = new MQOObjectFactory(pEnv);
	HRESULT hr = pEnv->AddObjectFactory("loadMQO", pFactory);
	if(FAILED(hr)) {
		return hr;
	}

	pFactory->Release();
	pFactory = NULL;

	return pEnv->PrintConsole("Registered: MQO");
}

// ܂B
STDMETHODIMP MQOPlugin::Detach()
{
	return S_OK;
}
