#include "StdAfx.h"
#include "TestPlugin.h"

// \z܂B
TestPlugin::TestPlugin()
{
	m_pEnv = NULL;
}

// j܂B
TestPlugin::~TestPlugin()
{
	if(m_pEnv != NULL) {
		m_pEnv->Release();
		m_pEnv = NULL;
	}
}

// A^b`܂B
STDMETHODIMP TestPlugin::Attach(IARGPluginEnvironment* pEnv)
{
	if(pEnv == NULL) {
		return E_POINTER;
	}
	m_pEnv = pEnv;
	m_pEnv->AddRef();

	return pEnv->PrintConsole("TestPlugin: Attached");
}

// ܂B
STDMETHODIMP TestPlugin::Detach()
{
	if(m_pEnv != NULL) {
		m_pEnv->Release();
		m_pEnv = NULL;
	}
	return S_OK;
}
