#pragma once

#include <plugin/ARGBaseDispatchableObject.h>
#include <plugin/IARGPluginEnvironment.h>
#include <GL/glut.h>

/**
* VRMLIuWFNg̎łB
*/
class VRMLObject : public ARGBaseDispatchableObject
{
public:

	/**
	* \z܂B
	*/
	VRMLObject(IARGPluginEnvironment* pEnv, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~VRMLObject();

	/**
	* ǂݏo܂B
	*/
	HRESULT Load(const char* path);

	/**
	* `悵܂B
	*/
	STDMETHODIMP Draw();

	/**
	* AChȌsȂ܂B
	*/
	STDMETHODIMP OnIdle();

	/**
	* IDispatch̎B
	*/
	STDMETHODIMP Invoke(DISPID dispIdMember, REFIID riid, LCID  lcid, WORD  wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, unsigned int *puArgErr);

private:

	/**
	* ITypeInfo𐶐܂B
	*/
	HRESULT CreateTypeInfo();

	/**
	* vOCsێ܂B
	*/
	IARGPluginEnvironment* m_pEnv;

	/**
	* t@CpXێ܂B
	*/
	string m_path;

	/**
	* S_XWB
	*/
	GLfloat m_x;

	/**
	* S_YWB
	*/
	GLfloat m_y;

	/**
	* S_ZWB
	*/
	GLfloat m_z;

	/**
	* VRML IDB
	*/
	int m_iVRMLId;

};
