// js32test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <js/JSEngineFactory.h>
#include <js/StringJSCode.h>
#include <ar/ARWindow.h>

#define RETURN(hr) \
	return hr;


int _tmain(int argc, _TCHAR* argv[])
{
	PREPARE_DEBUG();

	{
		JSEngineFactory engineFactory;

		// 
		IJSEngine* pEngine = NULL;
		HRESULT hr = engineFactory.Create(& pEngine);
		if(FAILED(hr)) {
			RETURN(hr);
		}
	 
		IJSContext* pContext = NULL;
		hr = pEngine->CreateContext(& pContext);
		if(FAILED(hr)) {
			pEngine->Destroy();
			pEngine = NULL;
			RETURN(hr);
		}

		{
			StringJSCode code("alert('sample!!');");

			hr = pContext->Evaluate(& code);
			if(FAILED(hr)) {
				pContext->Destroy();
				pContext = NULL;
				pEngine->Destroy();
				pEngine = NULL;
				RETURN(hr);
			}
		}

		// j
		if(pContext != NULL) {
			pContext->Destroy();
			pContext = NULL;
		}

		if(pEngine != NULL) {
			pEngine->Destroy();
			pEngine = NULL;
		}
	}

	RETURN(S_OK);
}

