#pragma once

#include "../common/ISource.h"
#include "../common/IImage.h"

/**
* 摜ǂݍ݂ʒm܂B
*/
class IImageLoaderNotify
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;
	
	/**
	* Ƃʒm܂B
	*/
	virtual HRESULT NotifySuccess(IImage* pImage) = 0;

	/**
	* sƂʒm܂B
	*/
	virtual HRESULT NotifyFailed(const char* message) = 0;
};

/**
* 摜ǂݍ݃WbÑC^tF[XB
*/
class IImageLoader
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* ftHgTCYݒ肵܂B
	*/
	virtual HRESULT SetDefaultSize(int width, int height) = 0;
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(const char* path, IImageLoaderNotify* pNotify) = 0;
	
	/**
	* 摜ǂݍ݂܂B
	*/
	virtual HRESULT Load(ISource* pSource, IImageLoaderNotify* pNotify) = 0;

};