#pragma once

class URLPath;

/**
* fBXNpXB
*/
class DiscPath
{
public:

	/**
	* \z܂B
	*/
	DiscPath(const char* path, HRESULT* phr);

	/**
	* \z܂B
	*/
	DiscPath(vector<string>& elems, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~DiscPath();

	/**
	* pXvf̐擾܂B
	*/
	HRESULT GetPathElementCount(int* pCount);

	/**
	* pXvf擾܂B
	*/
	HRESULT GetPathElement(int index, string& pathElem);

	/**
	* ΃pXǂ擾܂B
	*/
	HRESULT IsAbsolute(bool* pAbsolute);

	/**
	* pX폜܂B
	*/
	HRESULT RemoveLast();

	/**
	* pXɒǉ܂B
	*/
	HRESULT AddLast(const char* element);

	/**
	* 񉻂܂B
	*/
	HRESULT ToString(string& path);

	/**
	* URL擾܂B
	*/
	HRESULT GetURL(string& url);
	
private:

	/**
	* ͂܂B
	*/
	HRESULT Parse(const char* path);

	/**
	* pXvfێ܂B
	*/
	vector<string> m_elements;

};
