#pragma once

#include "IProperty.h"

/**
* ʂARGBtH[}bgłB
*/
typedef struct __tagCOMMON_ARGB {
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;
}COMMON_ARGB;


/**
* 摜̃C^tF[XB
*/
class IImage
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* 摜ŐV̏ԂɍXV܂B
	*/
	virtual HRESULT Refresh() = 0;
	
	/**
	* 擾܂B
	*/
	virtual int GetWidth() = 0;
	
	/**
	* 擾܂B
	*/
	virtual int GetHeight() = 0;

	/**
	* Materialp̃At@l擾܂B
	*/
	virtual double GetMaterialAlpha() = 0;
	
	/**
	* sNZ̏擾܂B
	*/
	virtual HRESULT GetPixel(int x, int y, COMMON_ARGB* pARGB) = 0;

	/**
	* Dirtyǂ𔻒肵܂B
	*/
	virtual HRESULT IsDirty(bool* pDirty) = 0;

	/**
	* Dirtyǂݒ肵܂B
	*/
	virtual HRESULT SetDirty(bool dirty) = 0;

	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(INamedProperty** ppProp) = 0;

};