#include "StdAfx.h"
#include "ImageFactory.h"
#include "LocalSource.h"

// 摜̓erbg}bvo͂܂B(eXgp)
HRESULT ImageFactory::DumpBitmap(const char* path, IImage* pImage)
{
	if(path == NULL || pImage == NULL) {
		return E_POINTER;
	}

  int              i,j;              /* [vpϐ                   */
  int              pad;              /* 32bitÊ߂̃pfBO    */
  int              imgsize;          /* C[W̃TCY               */
  unsigned char   *buf, *buf_top;     /* 摜f[^Ƃ̐擪|C^   */
  BITMAPFILEHEADER bf;                  /* t@Cwb_                 */
  BITMAPINFOHEADER bi;                  /* t@Cwb_                 */

  FILE* fp = fopen(path, "wb");

  if(fp == NULL)     /* ُ                       */
    return E_FAIL;

  /* ------------------------- wb_쐬 ---------------------------- */
  int x = pImage->GetWidth();
  int y = pImage->GetHeight();
  pad = (x * 3 + 3) / 4 * 4 - x * 3; /* 32bitEɂpfBO  */
  imgsize = (x * 3 + pad) * y;       /* o͂ꑝf[^TCY     */

  bf.bfType          = *(WORD*)"BM";
  bf.bfSize          = imgsize
                     + sizeof(BITMAPFILEHEADER)
                     + sizeof(BITMAPINFOHEADER);
  bf.bfReserved1     = 0;
  bf.bfReserved2     = 0;
  bf.bfOffBits       = sizeof(BITMAPFILEHEADER)
                     + sizeof(BITMAPINFOHEADER);
  bi.biSize          = sizeof(BITMAPINFOHEADER);
  bi.biWidth         = x;
  bi.biHeight        = y;
  bi.biPlanes        = 1;
  bi.biBitCount      = 24;
  bi.biCompression   = 0;
  bi.biSizeImage     = imgsize;
  bi.biXPelsPerMeter = 0;
  bi.biYPelsPerMeter = 0;
  bi.biClrUsed       = 0;
  bi.biClrImportant  = 0;

  /* ------------------------- wb_o ---------------------------- */
  if(fwrite((void*)&bf,sizeof(BITMAPFILEHEADER),1,fp) != 1)
    return NULL;                     /* ݎs                   */
  if(fwrite((void*)&bi,sizeof(BITMAPINFOHEADER),1,fp) != 1)
    return NULL;                     /* ݎs                   */

  /* ------------------------- o̓obt@m ---------------------- */
  buf_top = buf = (unsigned char*)malloc(imgsize);
  if(buf_top == NULL)
    return NULL;                     /* mێs                 */

  /* ------------------------- f[^ ---------------------------- */
  for(i = y - 1 ; i >= 0 ; i--){
    for(j = 0 ; j < x ; j++){
		COMMON_ARGB argb;
		HRESULT hr = pImage->GetPixel(j, i, & argb);
		if(FAILED(hr)) {
			  free(buf_top);
			  fclose(fp);
		}
      *(buf++) = argb.b;
      *(buf++) = argb.g;
      *(buf++) = argb.r;
    }
    for(j = 0;j < pad;j++)
      *(buf++) = 0;
  }
  
  /* ------------------------- 摜f[^o ------------------------ */
  if(fwrite((void*)buf_top,1,imgsize,fp) != imgsize){
    free(buf_top);
    return NULL;                     /* ݎs                   */
  }
  /* ------------------------- ׂĐ ---------------------------- */
  free(buf_top);
  fclose(fp);
  return S_OK;	
}


// \z܂B
ImageFactory::ImageFactory(void)
{
	;
}

// j܂B
ImageFactory::~ImageFactory(void)
{
	;
}

// ܂B
HRESULT ImageFactory::Load(const char* path, IImage** ppSource)
{
	return E_NOTIMPL;
}

// \[X[h܂B
HRESULT ImageFactory::Load(ISource* pSource, IImage** ppImage)
{
	return E_NOTIMPL;
}

