#pragma once

/**
* URLpXIuWFNgłB
*/
class URLPath
{
public:

	/**
	* URLGR[hsȂ܂B
	*/
	static HRESULT EncodeURLPath(const char* path, string& epath);

	/**
	* URLfR[hsȂ܂B
	*/
	static HRESULT DecodeURLPath(const char* path, string& epath);

private:

	/**
	* %ŊJnĂ邩ǂ𔻒肵܂B
	*/
	static HRESULT StartWithPerc(const char* path, int* pValue);

public:

	/**
	* \z܂B
	*/
	URLPath(const char* path, HRESULT* phr);

	/**
	* \z܂B
	*/
	URLPath(const char* scheme, const char* hostName, int portNumber, vector<string> pathElements, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~URLPath();

	/**
	* pXvf̐擾܂B
	*/
	HRESULT GetPathElementCount(int* pCount);

	/**
	* pXvf擾܂B
	*/
	HRESULT GetPathElement(int index, string& pathElem);

	/**
	* pX폜܂B
	*/
	HRESULT RemoveLastPathElement();

	/**
	* pXɒǉ܂B
	*/
	HRESULT AddLastPathElement(const char* element);

	/**
	* pX擪ɒǉ܂B
	*/
	HRESULT AddFirstPathElement(const char* element);

	/**
	* ΃pXǂ擾܂B
	*/
	HRESULT IsAbsolute(bool* pAbsolute);

	/**
	* pX擾܂B
	*/
	HRESULT GetRealPath(string& path);

	/**
	* URL擾܂B
	*/
	HRESULT GetAbsoluteURL(const char* path, string& url);

	/**
	* 񉻂܂B
	*/
	HRESULT ToString(string& path);
	
private:

	/**
	* ͂܂B
	*/
	HRESULT Parse(const char* path);

	/**
	* ͂܂B
	*/
	HRESULT ParseHostAndPath(const char* path);

	/**
	* ͂܂B
	*/
	HRESULT ParsePath(const char* path);

	/**
	* XL[ێ܂B
	*/
	string m_scheme;

	/**
	* zXgێ܂B
	*/
	string m_hostName;

	/**
	* |[gԍێ܂B
	*/
	int m_iPortNumber;

	/**
	* pXvfێ܂B
	*/
	vector<string> m_elements;

};
