#pragma once

#include "JSMemberCollection.h"
#include "../common/DispatchWrapper.h"

/**
* IuWFNgێf[^̃L[łB
*/
#define JSDISPATCH_IDISPATCH "IDispatch"

/**
* WindowJavaScriptbp[łB
*/
class JSDispatch : public JSMemberCollection
{
public:

	/**
	* VARIANTJSVALɕϊ܂B
	*/
	static HRESULT ConvertVARIANTtoJSVAL(JSEngineContext* pContext, VARIANT* pVar, jsval* pJsval);

	/**
	* JSVALVARIANTɕϊ܂B
	*/
	static HRESULT ConvertJSVALtoVARIANT(JSEngineContext* pContext, jsval val, VARIANT* pVar, VARTYPE vt);

	/**
	* \z܂B
	*/
	JSDispatch(IDispatch* pDispatch, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~JSDispatch();

	/**
	* JavaScriptGWƃIuWFNgݒ肵܂B
	*/
	virtual HRESULT Attach(JSEngineContext* pContext, JSObject* pObject);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* j̏ݒ肵܂B
	*/
	static void FinalizeOp(JSContext* cx, JSObject* obj);

	/**
	* Iɍ폜邩ǂݒ肵܂B
	*/
	HRESULT SetAutoDelete(bool autoDelete);

	/**
	* IuWFNgɊ֘AtĂf[^擾܂B
	*/
	virtual HRESULT GetData(const char* name, void** ppv);

protected:

	/**
	* ܂B
	*/
	virtual HRESULT InitMembers();
	
	/**
	* vpeBݒ肵܂B
	*/
	virtual HRESULT SetProperty(JSContext *cx, JSObject *obj, const char* name, jsval vp);
	
	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(JSContext* cx, JSObject* obj, const char* name, jsval *vp);
	
	/**
	* ֐s܂B
	*/
	virtual HRESULT InvokeFunction(JSContext *cx, JSObject *obj, const char* name, uintN argc, jsval *argv, jsval *rval);

private:

	/**
	* Dispatchێ܂B
	*/
	DispatchWrapper* m_pDispatch;

	/**
	* Iɔj܂B
	*/
	bool m_bAutoDelete;
};
