#pragma once

#include <jsapi.h>
#include <GL/gl.h>

/**
* JavaScriptl̃bp[NXB
*/
class JSValueWrapper
{
public:

	/**
	* \z܂B
	*/
	JSValueWrapper(JSContext* pContext, jsval value);

	/**
	* j܂B
	*/
	virtual ~JSValueWrapper();
	
	/**
	* lݒ肵܂B
	*/
	HRESULT Set(jsval value);

	/**
	* l擾܂B
	*/
	HRESULT Get(jsval* pValue);

	/**
	* booll擾܂B
	*/
	HRESULT GetBool(bool* pValue);

	/**
	* intl擾܂B
	*/
	HRESULT GetInt(int* pValue);

	/**
	* GLfloatl擾܂B
	*/
	HRESULT GetGLfloat(GLfloat* pFloat);

	/**
	* GLfloatl擾܂B
	*/
	HRESULT GetGLfloat(const char* name, GLfloat* pFloat);

	/**
	* doublel擾܂B
	*/
	HRESULT GetDouble(double* pDouble);

	/**
	* IuWFNgWƉ߂Ēl擾܂B
	*/
	HRESULT GetXYZ(GLfloat* pX, GLfloat* pY, GLfloat* pZ);

	/**
	* IuWFNgFƉ߂Ēl擾܂B
	*/
	HRESULT GetRGBA(GLfloat* pFloats);

	/**
	* JSVALl擾܂B
	*/
	HRESULT GetJSVAL(const char* name, JSValueWrapper* pValue);

	/**
	* boollݒ肵܂B
	*/
	HRESULT SetBool(bool value);

	/**
	* intlݒ肵܂B
	*/
	HRESULT SetInt(int value);

	/**
	* GLfloatlݒ肵܂B
	*/
	HRESULT SetGLfloat(GLfloat value);

	/**
	* doublelݒ肵܂B
	*/
	HRESULT SetDouble(double value);

	/**
	* GLfloatlݒ肵܂B
	*/
	HRESULT SetGLfloat(const char* name, GLfloat value);

	/**
	* WIuWFNgɕϊ܂B
	*/
	HRESULT SetXYZ(GLfloat x, GLfloat y, GLfloat z);

	/**
	* FIuWFNgɕϊ܂B
	*/
	HRESULT SetRGBA(const GLfloat* pFloats);

	/**
	* JSVALlݒ肵܂B
	*/
	HRESULT SetJSVAL(const char* name, JSValueWrapper* pValue);

	/**
	* l擾܂B
	*/
	HRESULT GetString(string& str);

	/**
	* lݒ肵܂B
	*/
	HRESULT SetString(const char* str);

private:
	
	/**
	* ReLXgێ܂B
	*/
	JSContext* m_pContext;
	
	/**
	* lێ܂B
	*/
	jsval m_value;
};
