#pragma once

#include "ICaptureDevice.h"

#include <AR/video.h>
#include <AR/gsub_lite.h>

/**
* ICaptureDevicelibARVideo𗘗płB
*/
class ARCaptureDevice : public ICaptureDevice
{
public:

	/**
	* \z܂B
	*/
	ARCaptureDevice();

	/**
	* j܂B
	*/
	virtual ~ARCaptureDevice(void);

	/**
	* ̃IuWFNgj܂B
	* p҂͂̃\bhʂăIuWFNgj܂B
	*/
	virtual void Destroy();

	/**
	* foCX擾܂B
	*/
	virtual HRESULT GetDeviceCount(int* pCount);

	/**
	* foCX擾܂B
	*/
	virtual HRESULT GetDevice(int index, string& name, CAPTURE_DEVICE_ATTR* pAttr);

	/**
	* ܂B
	*/
	virtual HRESULT Init(const char* config);

	/**
	* J`܂B
	*/
	virtual HRESULT InitCamera(const char* config);

	/**
	* TCY擾܂B
	*/
	virtual HRESULT GetSize(int* pWidth, int* pHeight);

	/**
	* OpenGLp̕ϊs擾܂B
	*/
	virtual HRESULT GetProjectionMatrix(double* pMatrix);

	/**
	* foCXJn܂B
	* ̒iKOpenGL݂łKv܂B
	*/
	virtual HRESULT Start();

	/**
	* foCX~܂B
	*/
	virtual HRESULT Stop();

	/**
	* C[W擾܂B
	*/
	virtual HRESULT GetImage(unsigned char** ppData);

	/**
	* ŌGetImagef[^`悵܂B
	*/
	virtual HRESULT Draw();

	/**
	* ̃t[Lv`܂B
	*/
	virtual HRESULT CaptureNext();

	/**
	* ݂̏|[g܂B
	*/
	virtual HRESULT ReportStatus(ostream* pOut);

private:

	/**
	* QƉ񐔂Z܂B
	*/
	LONG AddRef();

	/**
	* QƉ񐔂Z܂B
	*/
	LONG Release();

	/**
	* ݒێ܂B
	*/
	ARGL_CONTEXT_SETTINGS_REF m_arglSettings;

	/**
	* cparamێ܂B
	*/
	ARParam m_cparam;

	/**
	* Lv`f[^ێ܂B
	*/
	ARUint8* m_pData;

	/**
	* QƐێ܂B
	*/
	LONG m_cRef;

};
