#pragma once

/**
* Lv`foCX̏ێ܂B
*/
typedef struct __tagCAPTURE_DEVICE_ATTR
{
	bool enabled;
}CAPTURE_DEVICE_ATTR;

/**
* Lv`foCX̒ۂłB
*/
class ICaptureDevice
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* foCX擾܂B
	*/
	virtual HRESULT GetDeviceCount(int* pCount) = 0;

	/**
	* foCX擾܂B
	*/
	virtual HRESULT GetDevice(int index, string& name, CAPTURE_DEVICE_ATTR* pAttr) = 0;

	/**
	* ܂B
	*/
	virtual HRESULT Init(const char* config) = 0;

	/**
	* J`܂B
	*/
	virtual HRESULT InitCamera(const char* config) = 0;

	/**
	* TCY擾܂B
	*/
	virtual HRESULT GetSize(int* pWidth, int* pHeight) = 0;

	/**
	* OpenGLp̕ϊs擾܂B
	*/
	virtual HRESULT GetProjectionMatrix(double* pMatrix) = 0;

	/**
	* foCXJn܂B
	* ̒iKOpenGL݂łKv܂B
	*/
	virtual HRESULT Start() = 0;

	/**
	* foCX~܂B
	*/
	virtual HRESULT Stop() = 0;

	/**
	* C[W擾܂B
	*/
	virtual HRESULT GetImage(unsigned char** ppData) = 0;

	/**
	* ŌGetImagef[^`悵܂B
	*/
	virtual HRESULT Draw() = 0;

	/**
	* ̃t[Lv`܂B
	*/
	virtual HRESULT CaptureNext() = 0;

	/**
	* ݂̏|[g܂B
	*/
	virtual HRESULT ReportStatus(ostream* pOut) = 0;

};


