#pragma once

#include "MMDVertexList.h"
#include "../IMMDTextureProvider.h"
#include "../io/clsPMDFile.h"

class MMDBone;

/**
* Materialێ܂B
*/
class MMDMaterial
{
public:

	/**
	* \z܂B
	*/
	MMDMaterial(const PMD_MATERIAL_RECORD* pMaterial, HRESULT* phr);

	/**
	* j܂B
	*/
	~MMDMaterial(void);

	/**
	* ܂B
	*/
	HRESULT Init(MMDVertexList* pVertexList, vector<MMDBone*> bones, int offset, int* pNextOffset);

	/**
	* eNX`̏sȂ܂B
	*/
	HRESULT Prepare(IMMDTextureProvider* pTextureProvider);

	/**
	* _obt@XV܂B
	*/
	HRESULT UpdateVertexBuffer(float scale);

	/**
	* `悵܂B
	*/
	HRESULT Draw();

private:

	/**
	* Iɒ_Ǘ邽߂̍\̂łB
	*/
	typedef struct {		
		MMD_VERTEX_DESC* pOriginalVert;
		MMD_VERTEX_TEXUSE* pCurrentVert;
	} MMD_VERTEX_UNIT;

	/**
	* Materialێ܂B
	*/
	PMD_MATERIAL_RECORD m_material;

	/**
	* eNX`ێ܂B
	*/
	TEXTURE_DESC m_texture;

	/**
	* ŏI_obt@ێ܂B
	*/
	MMD_VERTEX_TEXUSE* m_pCurrentVertexes;

	/**
	* _Xgێ܂B
	*/
	MMD_VERTEX_UNIT* m_pVertexes;

};
