#pragma once

#include "IClock.h"
#include <plugin/ARGMutex.h>

/**
* NbN̊{IȎłB
*/
class BasicClock : public IClock
{
public:

	/**
	* \z܂B
	*/
	BasicClock();

	/**
	* j܂B
	*/
	virtual ~BasicClock();

	/**
	* Đ擾܂B
	*/
	HRESULT GetCurrentTimeMS(LONGLONG* pMilliseconds);

	/**
	* Đǂ擾܂B
	*/
	HRESULT IsPlaying(bool* pValue);

	/**
	* Đ܂B
	*/
	HRESULT Play();

	/**
	* ~܂B
	*/
	HRESULT Stop();

private:

	/**
	* Đǂێ܂B
	*/
	bool m_bPlaying;

	/**
	* x[XƂȂt[ԍێ܂B
	*/
	LONGLONG m_baseTime;

	/**
	* ĐJntickCountێ܂B
	*/
	DWORD m_baseTickCount;

	/**
	* Ōɏ̃t[ԍێ܂B
	*/
	LONGLONG m_lastTime;

	/**
	* ŌɏtickCountێ܂B
	*/
	DWORD m_lastTickCount;

	/**
	* pIuWFNgێ܂B
	*/
	ARGMutex m_clockMutex;

};
