#include "StdAfx.h"
#include "VRMLPlugin.h"
#include "VRMLObjectFactory.h"

// \z܂B
VRMLPlugin::VRMLPlugin(void)
{
}

// j܂B
VRMLPlugin::~VRMLPlugin(void)
{
}

// A^b`܂B
STDMETHODIMP VRMLPlugin::Attach(IARGPluginEnvironment* pEnv)
{
	if(pEnv == NULL) {
		return E_POINTER;
	}

	VRMLObjectFactory* pFactory = new VRMLObjectFactory(pEnv);
	HRESULT hr = pEnv->AddObjectFactory("loadVRML", pFactory);
	if(FAILED(hr)) {
		return hr;
	}

	pFactory->Release();
	pFactory = NULL;

	return pEnv->PrintConsole("Registered: VRML");
}

// ܂B
STDMETHODIMP VRMLPlugin::Detach()
{
	return S_OK;
}
