#pragma once
#include "arpattern.h"
#include "ARGraphics.h"

class TestARPattern :
	public ARPattern
{
public:

	/**
	* \z܂B
	*/
	TestARPattern(HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~TestARPattern(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* GraphicsIuWFNg擾܂B
	*/
	ARGraphics* CreateGraphics(ARWindow* pWindow);

protected:

	/**
	* oԂʒm܂B
	* ʓɃ}[J[oĂȂꍇApDetectedNULLݒ肳܂B
	*/
	virtual HRESULT Detect(ARMarkerInfoContainer* pDetectedC);

private:

	/**
	* IuWFNg`悵܂B
	*/
	HRESULT Draw();

	/**
	* p^[̕ێ܂B
	*/
	double m_patternWidth;

	/**
	* p^[̒S_ێ܂B
	*/
	double m_patternCenter[2];

	/**
	* ϊsێ܂B
	*/
	double m_trans[3][4];

	/**
	* \ׂǂێ܂B
	*/
	bool m_visible;

	/**
	* GraphicsNXێ܂B
	*/
	class GraphicsImpl : public ARGraphics
	{
	public:

		/**
		* \z܂B
		*/
		GraphicsImpl(ARWindow* pWindow, TestARPattern* pOwner);

		/**
		* j܂B
		*/
		virtual ~GraphicsImpl();

		/**
		* j܂B
		*/
		void Destroy();

		/**
		* `悵܂B
		*/
		HRESULT Draw();

		/**
		* IJSObject擾܂B
		*/
		IJSObject* GetJSObject();

	private:

		/**
		* I[i[ێ܂B
		*/
		TestARPattern* m_pOwner;
	};
};
