#pragma once
#include "ARJSGraphicsModel.h"

/**
* ́B
*/
class ARJSSolidCube :
	public ARJSGraphicsModel
{
public:

	/**
	* \z܂B
	*/
	ARJSSolidCube(ARWindow* pOwner);

	/**
	* j܂B
	*/
	virtual ~ARJSSolidCube(void);

	/**
	* j܂B
	*/
	virtual void Destroy();

protected:

	/**
	* f`悵܂B
	*/
	virtual HRESULT DrawModel();

	/**
	* vpeB𐶐܂B
	*/
	virtual HRESULT CreateProperty(INamedProperty** ppProp);

private:

	/**
	* TCYB
	*/
	GLfloat m_size;

	/**
	* B
	*/
    GLfloat m_matAmbient[4];

	/**
	* ʌB
	*/
    GLfloat m_matFlash[4];

	/**
	* B
	*/
    GLfloat m_matFlashShiny[1];

	/**
	* vpeB̎łB
	*/
	class CubePropertyImpl : public ModelPropertyImpl
	{
	public:

		/**
		* \z܂B
		*/
		CubePropertyImpl(ARJSSolidCube* pOwner);

		/**
		* j܂B
		*/
		virtual ~CubePropertyImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();
		
		/**
		* ܂B
		*/
		virtual HRESULT Init();

	protected:
		
		/**
		* doublẽvpeB擾܂B
		*/
		virtual HRESULT GetDoubleProperty(const char* name, double* pValue);
		
		/**
		* doublẽvpeBݒ肵܂B
		*/
		virtual HRESULT SetDoubleProperty(const char* name, double value);

	private:

		/**
		* o擾܂B
		*/
		HRESULT GetMember(GLfloat* pRGBA, const char* propName, GLfloat** ppValue);

		/**
		* I[i[ێ܂B
		*/
		ARJSSolidCube* m_pOwner;
	};
};
