#include "StdAfx.h"
#include "Mutex.h"

// \z܂B
Mutex::Mutex()
{
	InitializeCriticalSection(&m_crit);
}

// j܂B
Mutex::~Mutex()
{
	DeleteCriticalSection(&m_crit);
}

// Jn܂B
void Mutex::Begin()
{
	EnterCriticalSection(&m_crit);
}

// I܂B
void Mutex::End()
{
	LeaveCriticalSection(&m_crit);
}
