
#include "ARGBaseUnknown.h"
#include "IARGObjectFactory.h"

/**
* IuWFNg̒ۃNXłB
*/
class ARGBaseObject : public ARGBaseUnknown, public IARGObject
{
public:

	/**
	* \z܂B
	*/
	ARGBaseObject()
	{
		;
	};

	/**
	* j܂B
	*/
	virtual ~ARGBaseObject()
	{
		;
	};

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	virtual STDMETHODIMP QueryInterface(const IID& riid, void** ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}

		if(riid == IID_IARGObject) {
			*ppv = static_cast<IARGObject*>(this);
			AddRef();
			return S_OK;
		}

		return ARGBaseUnknown::QueryInterface(riid, ppv);
	};

	/**
	* pNbNݒ肵܂B
	*/
	virtual STDMETHODIMP SetSyncClock(IARGSyncClock* pClock)
	{
		return S_OK;
	};

	/**
	* pNbN擾܂B
	*/
	virtual STDMETHODIMP GetSyncClock(IARGSyncClock** ppClock)
	{
		return S_FALSE;
	};

	/**
	* Cxg擾܂B
	*/
	virtual STDMETHODIMP GetEventCount(int* pCount)
	{
		if(pCount == NULL) {
			return E_POINTER;
		}
		*pCount = 0;
		return S_OK;
	};

	/**
	* Cxg擾܂B
	*/
	virtual STDMETHODIMP GetEvent(int index, char* pEventName, int maxLen, int* pLen)
	{
		return E_NOTIMPL;
	};

	/**
	* CxgfBXpb`ǉ܂B
	*/
	virtual STDMETHODIMP AddEventDispatcher(const char* name, IARGEventDispatcher* pDispatcher)
	{
		return E_NOTIMPL;
	};

	/**
	* CxgfBXpb`폜܂B
	* pDispatcherNULL̏ꍇnameɊւ邷ׂẴfBXpb`폜܂B
	*/
	virtual STDMETHODIMP RemoveEventDispatcher(const char* name, IARGEventDispatcher* pDispatcher)
	{
		return E_NOTIMPL;
	};

};
