#include "StdAfx.h"
#include "CaptureDeviceFactory.h"
#include "ARCaptureDevice.h"

// \z܂B
CaptureDeviceFactory::CaptureDeviceFactory(void)
{
	;
}

// j܂B
CaptureDeviceFactory::~CaptureDeviceFactory(void)
{
	;
}

// ܂B
HRESULT CaptureDeviceFactory::Create(ICaptureDevice** ppDevice)
{
	if(ppDevice == NULL) {
		return E_POINTER;
	}

	HRESULT hr = S_OK;
	ARCaptureDevice* pNewDevice = new ARCaptureDevice();
	if(pNewDevice == NULL) {
		return E_OUTOFMEMORY;
	}
	if(FAILED(hr)) {
		pNewDevice->Destroy();
		pNewDevice = NULL;
		*ppDevice = NULL;
		return hr;
	}

	*ppDevice = pNewDevice;
	return S_OK;
}