#pragma once

#include "IWindow.h"
#include "../common/Mutex.h"

/**
* EBhE̒ۂłB
*/
class AbstractWindow : public IWindow
{
public:

	/**
	* \z܂B
	*/
	AbstractWindow();
	
	/**
	* j܂B
	*/
	virtual ~AbstractWindow();

	/**
	* eEBhEnhݒ肵܂B
	*/
	virtual HRESULT SetParent(HWND hWnd);

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	virtual HRESULT SetNotify(IWindowNotify* pNotify);

	/**
	* GLp̃tbNǉ܂B
	*/
	virtual HRESULT AddGLHook(IWindowGLHook* pHook);

	/**
	* GLp̃tbN폜܂B
	*/
	virtual HRESULT RemoveGLHook(IWindowGLHook* pHook);
	
	/**
	* R\[ɏoȂ܂B
	*/
	virtual HRESULT PrintLine(const char* line);
	
	/**
	* A[g\Ȃ܂B
	*/
	virtual HRESULT Alert(const char* message);
	
	/**
	* Xe[^XbZ[W\Ȃ܂B
	*/
	virtual HRESULT SetStatus(const char* status);

	/**
	* ݂̏|[g܂B
	*/
	virtual HRESULT ReportStatus(ostream* pOut);

	/**
	* `ݒ肵܂B
	*/
	virtual HRESULT SetRect(int x, int y, int width, int height);

	/**
	* `擾܂B
	*/
	virtual HRESULT GetRect(int* pX, int* pY, int* pWidth, int* pHeight);

	/**
	* ǂݍݗpGLReLXgJn܂B
	*/
	virtual HRESULT BeginGLLoading();

	/**
	* ǂݍݗpGLReLXgI܂B
	*/
	virtual HRESULT EndGLLoading();

protected:

	/**
	* `̑OłB
	*/
	virtual HRESULT NotifyPreDraw();

	/**
	* `̌㏈łB
	*/
	virtual HRESULT NotifyPostDraw();

	/**
	* ʒmIuWFNgێ܂B
	*/
	IWindowNotify* m_pNotify;

	/**
	* tbNǗpMutexێ܂B
	*/
	Mutex m_hookMutex;

	/**
	* tbN̈ꗗێ܂B
	*/
	vector<IWindowGLHook*> m_hooks;

};


