#pragma once

/**
* EBhȄłB
*/
class IWindowNotify
{
public:

	/**
	* EBhEB
	*/
	virtual HRESULT OnCreate() = 0;

	/**
	* IdleB
	*/
	virtual HRESULT OnIdle() = 0;
	
	/**
	* `揈B
	*/
	virtual HRESULT OnDraw() = 0;

	/**
	* L[Cxg̏B
	*/
	virtual HRESULT OnKeyEvent(unsigned char key, int x, int y) = 0;
	
	/**
	* G[B
	*/
	virtual HRESULT OnError(HRESULT hr) = 0;

};

/**
* OpenGLtbN邽߂̃C^tF[XłB
*/
class IWindowGLHook
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* `̑OB
	*/
	virtual HRESULT OnPreDraw() = 0;

	/**
	* `̌㏈B
	*/
	virtual HRESULT OnPostDraw() = 0;

};

/**
* EBhE̒ۂłB
*/
class IWindow
{
public:

	/**
	* j܂B
	*/
	virtual void Destroy() = 0;

	/**
	* eEBhEnhݒ肵܂B
	*/
	virtual HRESULT SetParent(HWND hWnd) = 0;

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	virtual HRESULT SetNotify(IWindowNotify* pNotify) = 0;

	/**
	* GLp̃tbNǉ܂B
	*/
	virtual HRESULT AddGLHook(IWindowGLHook* pHook) = 0;

	/**
	* GLp̃tbN폜܂B
	*/
	virtual HRESULT RemoveGLHook(IWindowGLHook* pHook) = 0;

	/**
	* EBhE𐶐܂B
	*/
	virtual HRESULT Create(int width, int height) = 0;

	/**
	* C[vJn܂B
	*/
	virtual HRESULT RunMainLoop() = 0;

	/**
	* ĕ`悵܂B
	*/
	virtual HRESULT Redraw() = 0;

	/**
	* EBhE܂B
	*/
	virtual HRESULT Close() = 0;
	
	/**
	* R\[ɏoȂ܂B
	*/
	virtual HRESULT PrintLine(const char* line) = 0;
	
	/**
	* A[g\Ȃ܂B
	*/
	virtual HRESULT Alert(const char* message) = 0;
	
	/**
	* Xe[^XbZ[W\Ȃ܂B
	*/
	virtual HRESULT SetStatus(const char* status) = 0;

	/**
	* ݂̏|[g܂B
	*/
	virtual HRESULT ReportStatus(ostream* pOut) = 0;

	/**
	* `ݒ肵܂B
	*/
	virtual HRESULT SetRect(int x, int y, int width, int height) = 0;

	/**
	* `擾܂B
	*/
	virtual HRESULT GetRect(int* pX, int* pY, int* pWidth, int* pHeight) = 0;

	/**
	* ǂݍݗpGLReLXgJn܂B
	*/
	virtual HRESULT BeginGLLoading() = 0;

	/**
	* ǂݍݗpGLReLXgI܂B
	*/
	virtual HRESULT EndGLLoading() = 0;

};


